/*
 * qfsic[  p[\iEBhEj
 *
 *	By Masahiko Ito <m-ito@myh.no-ip.org>
 *	   Masahiko Ito <m-ito@mbox.kyoto-inet.or.jp>
 *
 *	1992/03/12 Ver 1.0	release
 *	1992/03/13 Ver 1.1			1. `rŒ~o@\ǉ
 *						2. EBhẼP[V͈̓`FbNǉ
 *						3. \[Xt@C̃}EXJ[\qbg|Cgl
 *						    _pw_setcptn ̎wlƓɂȂ悤ɏCB
 *						4. LOAD t@C SAVE ɕ\悤ɏCB
 *	1992/04/01 Ver 2.0	@\ǉ
 *						1. FILL ̈̓hׂ
 *						2. MAG  g\^ҏW
 *						3. COPY `̈敡
 *						4. STR  
 *						5. -gx IvV
 *	1992/07/06 Ver 2.1	C
 *						1. VKt@Cw肵ĂG[IƂȂ悤
 *						   CB
 *						2. STR Œ͎ɃoXG[̂
 *						   CB
 *						3. STR ͂ɑΉB
 *						4. l̃LoXTCY 318x198  320x200 
 *						   ύXB
 *						5. LoX̘gXs떂...(^^;
 *						6. FILL  CTRL+C ŋIo悤ɏCBiA
 *						   PwGraph.c,PwSignal.c Cj
 *	2018/09/11 Ver 2.2	C
 *						1. SAVE Ɏw肵t@C SAVE ɂ\
 *						   悤ɏCB
 *						2. MAG Ŕ͈͊O`悷sCB
 *						3. LOAD,SAVE ̃oXG[悤ɏCB
 *						dlύX
 *						4. DOT ŃJ[\EhOAe|CgԂ𒼐ŕ`
 *						   悤ɏCB
 */

#include	<stdio.h>
#include	<pwindow.h>
#include	<strings.h>
#include	<errno.h>
#include	<signal.h>
#include	<module.h>
#include	"PwGraph.h"
#include	"PwControl.h"
#include	"PwSignal.h"
#include	"PwToolKit.h"
#include	"RGTool.h"

short	BlackPat[16] =	{
					 0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
					 0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff
					};

/* RESOURCE */
struct pen {
	int		penwidth;
	int		penheight;
	short	penpat[16];
} PenPat[PENMAX];
short	FgPat[PATMAX][16];
short	McPat[32];
int		McHitX;
int		McHitY;

int		PenWidth;
int		PenHeight;

char	ResFile[128];
char	EditFile[128];

int		BaseWidth = BASEWIDTH;
int		BaseHeight = BASEHEIGHT;

char	DicM[64],DicS[64];

void	main(argc,argv)
int		argc;
char	*argv[];
{
	PWIN	*basewin,*ctrlwin,*palwin,*magwin=(PWIN *)NULL,*strwin=(PWIN *)NULL;
	PWGMAP	*basemap,*ctrlmap,*palmap,*magmap,*strmap,mapsave;
	static PWSIGNAL	sigrec = {-1,(PWIN *)NULL,-1,0,0,0};
	int		i,left,top,idx,sidx,eidx,x,y,sx,sy,ex,ey,ox=INVVAL,oy=INVVAL;
	int		src_sx=INVVAL,src_sy=INVVAL,src_ex=INVVAL,src_ey=INVVAL;
	int		width,height,attr,magloc_sw=OFF,magpress_sw=OFF,copysrc_sw=OFF;
	int		strwidth=0,strheight=0,strstyle=0,str_sw=OFF,fontstyle=DOT16;
	int		dmsv,penpatsv;
	short	(*fgpatsv)[16];
	int		basepress_sw = OFF,exit_sw = OFF,italic_sw=OFF,underline_sw=OFF;
	char	string[128],namebuffer[128];
	mod_exec	*modexec;
/* static łȂ 166:system stack overfrow !! */
	static BTNLIST	ctrlbl[CTRLBTNMAX+1],palbl[PALBTNMAX+1],strbl[STRBTNMAX+1];
	extern int	_PwFillMap();

	PwInitWin();
	intercept(PwIntercept);

	string[0] = '\0';
	ClearBtnList(ctrlbl,CTRLBTNMAX);
	ClearBtnList(palbl,PALBTNMAX);
	ClearBtnList(strbl,STRBTNMAX);

	PwGetMousePosition(PwGetRootWin(),&left,&top);

/* IvV */
	if (GetOpt(argc,argv) == -1){
		exit(0);
	}

/* \[Xǂݍ */
	if (GetRes(argc,argv) == -1){
		exit(0);
	}

/* ask68k load */
	modexec = modloadp(FEP_MODULE,(short)0,namebuffer);

/* EBhE */
	basewin = PwCreateWin(PwGetRootWin(),left+CTRLWIDTH,top,BaseWidth,
						  BaseHeight);
	PwSetWinAttr(basewin,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADER|
					WIN_MP_SHADEB|WIN_SIZE|WIN_DESTROY);
	PwSetWinTitle(basewin,"炭");
	write(PwGetWinPath(basewin),"\033[1v",4);

	ctrlwin = PwCreateWin(basewin,-CTRLWIDTH,0,CTRLWIDTH,CTRLHEIGHT);
	PwSetWinAttr(ctrlwin,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
	write(PwGetWinPath(ctrlwin),"\033[1v",4);

	palwin = PwCreateWin(basewin,0,BaseHeight+20,PALWIDTH,PALHEIGHT);
	PwSetWinAttr(palwin,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
	write(PwGetWinPath(palwin),"\033[1v",4);

/* EBhEʒuݒ */
	PwGetMousePosition(PwGetRootWin(),&left,&top);
	left += CTRLWIDTH;
	LocationCheck(&left,&top,basewin,ctrlwin,palwin,magwin,strwin);
	PwMoveWin(basewin,left,top);
/* EBhEI[v */
	PwOpenWin(basewin);

/* LoX */
	basemap = PwCreateMap(BaseWidth-2,BaseHeight-2);
	PwSetMapWin(basemap,basewin,1,1,BaseWidth-2,BaseHeight-2);
	PwSetFlushMode(basemap,FLS_NORMAL);

	PwClearArea(basemap,0,0,BaseWidth-2,BaseHeight-2);

/* pl */
	ctrlmap = PwCreateMap(CTRLWIDTH,CTRLHEIGHT);
	PwSetMapWin(ctrlmap,ctrlwin,0,0,CTRLWIDTH,CTRLHEIGHT);
	PwDrawRectangle(ctrlmap,0,0,CTRLWIDTH-1,CTRLHEIGHT-1);

	DrawPushButton(ctrlmap, 0,0,BTNWIDTH,BTNHEIGHT,"DOT",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap, BTNWIDTH,0,BTNWIDTH,BTNHEIGHT,"LINE",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap, 0,BTNHEIGHT,BTNWIDTH,BTNHEIGHT,"BOX",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT,BTNWIDTH,
					BTNHEIGHT,"BOXF",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap, 0,BTNHEIGHT*2,BTNWIDTH,BTNHEIGHT,
					"ARC",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT*2,BTNWIDTH,
					BTNHEIGHT,"ARCF",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap, 0,BTNHEIGHT*3,BTNWIDTH,BTNHEIGHT,
					"FILL",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT*3,BTNWIDTH,
					BTNHEIGHT,"MAG",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap, 0,BTNHEIGHT*4,BTNWIDTH,BTNHEIGHT,
					"COPY",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT*4,BTNWIDTH,
					BTNHEIGHT,"STR",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);

	DrawPushButton(ctrlmap, 0,BTNHEIGHT*6,BTNWIDTH,BTNHEIGHT,
					"SRC",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT*6,BTNWIDTH,
					BTNHEIGHT,"OR",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap, 0,BTNHEIGHT*7,BTNWIDTH,BTNHEIGHT,
					"XOR",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT*7,BTNWIDTH,
					BTNHEIGHT,"NOT",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);

	DrawPushButton(ctrlmap, 0,BTNHEIGHT*9,BTNWIDTH,BTNHEIGHT,
					"SAVE",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	DrawPushButton(ctrlmap,BTNWIDTH,BTNHEIGHT*9,BTNWIDTH,
					BTNHEIGHT,"LOAD",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);

	DrawPushButton(ctrlmap, 0,BTNHEIGHT*11,BTNWIDTH,BTNHEIGHT,
					"EXIT",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,ctrlbl);
	PwFlushMap(ctrlmap,FLS_NORMAL);
	PwSetFlushMode(ctrlmap,FLS_NORMAL);

	ReverseButton(ctrlbl,DOT);

	ReverseButton(ctrlbl,SRC);
	PwSetDrawMode(basemap,DM_COPY);
	dmsv = DM_COPY;

/* pbgpl */
	palmap = PwCreateMap(PALWIDTH,PALHEIGHT);
	PwSetMapWin(palmap,palwin,0,0,PALWIDTH,PALHEIGHT);
	PwDrawRectangle(palmap,0,0,PALWIDTH-1,PALHEIGHT-1);

	PwDrawLabel(palmap,0,0,BTNWIDTH,BTNHEIGHT,"PEN",LBL_CLOSED|TS_PLAIN);
	for (i = 0; i < PENMAX; i++){
		DrawPushButton(palmap,BTNWIDTH+ICONWIDTH*i,0,ICONWIDTH,ICONHEIGHT,
						 " ",LBL_CLOSED,palbl);
		SetPenSize(palmap,PenPat[i].penwidth,PenPat[i].penheight);
		PwSetPenForm(palmap,PenPat[i].penpat);
		DrawPoint(palmap,BTNWIDTH+ICONWIDTH/2+ICONWIDTH*i,ICONHEIGHT/2);
	}

	PwDrawLabel(palmap,0,BTNHEIGHT,BTNWIDTH,BTNHEIGHT,"PAT",LBL_CLOSED|TS_PLAIN);
	for (i = 0; i < PATMAX; i++){
		DrawPushButton(palmap,BTNWIDTH+ICONWIDTH*i,ICONHEIGHT,ICONWIDTH,
						 ICONHEIGHT," ",LBL_CLOSED,palbl);
		SetPenSize(palmap,16,16);
		PwSetPenForm(palmap,FgPat[i]);
		DrawPoint(palmap,BTNWIDTH+ICONWIDTH/2+ICONWIDTH*i,3*ICONHEIGHT/2);
	}
	PwFlushMap(palmap,FLS_NORMAL);
	PwSetFlushMode(palmap,FLS_NORMAL);

/* l */
	ReverseButton(palbl,DEFPEN);
	SetPenSize(basemap,PenPat[DEFPEN].penwidth,PenPat[DEFPEN].penheight);
	PwSetPenForm(basemap,PenPat[DEFPEN].penpat);
	penpatsv = DEFPEN;
	ReverseButton(palbl,DEFPAT);
	PwSetForeground(basemap,FgPat[DEFPAT-PENMAX]);
	fgpatsv = FgPat[DEFPAT-PENMAX];
/* J[\`ݒ */
	PwSetCursorPattern(basewin,McHitX,McHitY,McPat);
/* VOiݒ */
	PwSelectSignal(basewin,WIN_PRIORITY|WIN_LOCATE|WIN_PRESS|WIN_RELEASE| 
						   WIN_MOVE);
	PwSelectSignal(ctrlwin,WIN_PRIORITY|WIN_LOCATE|WIN_PRESS|WIN_RELEASE);
	PwSelectSignal(palwin,WIN_PRIORITY|WIN_LOCATE|WIN_PRESS|WIN_RELEASE);
/* ҏWt@Cǂݍ */
	if (EditFile[0] != '\0'){
		LoadFileToMap(EditFile,basemap);
	}
/* LoX tbV */
	PwFlushMap(basemap,FLS_NORMAL);
/* pXɐڑ */
	PwSetStdPath(basewin,MSK_STDIN|MSK_STDOUT|MSK_STDERR);

/* VOi[v */
	while(exit_sw == OFF){

		PwGetSignal(&sigrec);

		if (sigrec.win == basewin){
			switch (sigrec.type){
			case	WIN_PRIORITY_T:
			case	WIN_LOCATE_T:
				PwGetWinStatus(sigrec.win,&left,&top,&width,&height,&attr);
				LocationCheck(&left,&top,sigrec.win,ctrlwin,palwin,magwin,
								strwin);
				PwMoveWin(sigrec.win,left,top);
				break;
			case	WIN_PRESS_T:
				basepress_sw = ON;
				if       (ctrlbl[DOT].status == ON){
					PwGetMousePosition(basewin,&x,&y);
					DrawPoint(basemap,x,y);
					ox = x;
					oy = y;
				}else if (ctrlbl[LINE].status == ON){
					PwGetMousePosition(basewin,&sx,&sy);
					ox = ex = sx;
					oy = ey = sy;
					SetRubberBand(basemap,&mapsave);
					DrawLine(basemap,sx,sy,ex,ey);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
				}else if (ctrlbl[BOX].status == ON){
					PwGetMousePosition(basewin,&sx,&sy);
					ox = ex = sx;
					oy = ey = sy;
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ex,ey);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
				}else if (ctrlbl[BOXF].status == ON){
					PwGetMousePosition(basewin,&sx,&sy);
					ox = ex = sx;
					oy = ey = sy;
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ex,ey);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
				}else if (ctrlbl[ARC].status == ON){
					PwGetMousePosition(basewin,&sx,&sy);
					ox = ex = sx;
					oy = ey = sy;
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ex,ey);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
				}else if (ctrlbl[ARCF].status == ON){
					PwGetMousePosition(basewin,&sx,&sy);
					ox = ex = sx;
					oy = ey = sy;
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ex,ey);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
				}else if (ctrlbl[COPY].status == ON){
					if (copysrc_sw == OFF){
						PwGetMousePosition(basewin,&sx,&sy);
						ox = ex = sx;
						oy = ey = sy;
						SetRubberBand(basemap,&mapsave);
						DrawRectangle(basemap,sx,sy,ex,ey);
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
					}
				}
				break;
			case	WIN_RELEASE_T:
				if (basepress_sw == OFF){
					break;
				}
				basepress_sw = OFF;
				if       (ctrlbl[DOT].status == ON){
					PwGetMousePosition(basewin,&x,&y);
					if (x != ox || y != oy){
						DrawPoint(basemap,x,y);
						ox = x;
						oy = y;
					}
				}else if (ctrlbl[LINE].status == ON){
					PwGetMousePosition(basewin,&ex,&ey);
					SetRubberBand(basemap,&mapsave);
					DrawLine(basemap,sx,sy,ox,oy);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
					DrawLine(basemap,sx,sy,ex,ey);
				}else if (ctrlbl[BOX].status == ON){
					PwGetMousePosition(basewin,&ex,&ey);
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ox,oy);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
					DrawRectangle(basemap,sx,sy,ex,ey);
				}else if (ctrlbl[BOXF].status == ON){
					PwGetMousePosition(basewin,&ex,&ey);
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ox,oy);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
					FillRectangle(basemap,sx,sy,ex,ey);
				}else if (ctrlbl[ARC].status == ON){
					PwGetMousePosition(basewin,&ex,&ey);
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ox,oy);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
					DrawArc(basemap,sx,sy,ex,ey,0,360*64);
				}else if (ctrlbl[ARCF].status == ON){
					PwGetMousePosition(basewin,&ex,&ey);
					SetRubberBand(basemap,&mapsave);
					DrawRectangle(basemap,sx,sy,ox,oy);
					UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
					FillArc(basemap,sx,sy,ex,ey,0,360*64);
				}else if (ctrlbl[FILL].status == ON){
					PwGetMousePosition(basewin,&ex,&ey);
					PwFillField(basemap,ex,ey);
				}else if (ctrlbl[MAG].status == ON){
					if (magloc_sw == OFF){
						CopyMapToMag(basemap,ox,oy,magmap);
						magloc_sw = ON;
					}
				}else if (ctrlbl[COPY].status == ON){
					if (copysrc_sw == OFF){
						PwGetMousePosition(basewin,&ex,&ey);
						SetRubberBand(basemap,&mapsave);
						DrawRectangle(basemap,sx,sy,ox,oy);
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
						src_sx = sx;
						src_sy = sy;
						src_ex = ox = ex;
						src_ey = oy = ey;
						if ((src_sx != src_ex) || (src_sy != src_ey)){
							copysrc_sw = ON;
						}
					}else{
						PwGetMousePosition(basewin,&ex,&ey);
						SetRubberBand(basemap,&mapsave);
						DrawRectangle(basemap,src_sx,src_sy,src_ex,src_ey);
						DrawRectangle(basemap,src_sx-src_ex+ox,
										src_sy-src_ey+oy,ox,oy);
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
						CopyArea(basemap,basemap,src_sx,src_sy,src_ex,src_ey,
								ex,ey);
						copysrc_sw = OFF;
					}
				}else if (ctrlbl[STR].status == ON){
					if (str_sw == ON){
						PwGetMousePosition(basewin,&sx,&sy);
						SetRubberBand(basemap,&mapsave);
						DrawRectangle(basemap,ox,oy,ox+strwidth,oy+strheight);
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
						if (fontstyle == DOT16){
							PwDrawString(basemap,sx,sy,string,strstyle);
						}else{
							PwDrawString24(basemap,sx,sy,string,strstyle);
						}
						SetRubberBand(basemap,&mapsave);
						DrawRectangle(basemap,sx,sy,sx+strwidth,sy+strheight);
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
						ox = sx;
						oy = sy;
					}
				}
				break;
			case	WIN_MOVE_T:
				if       (ctrlbl[DOT].status == ON){
					if (basepress_sw == ON){
						PwGetMousePosition(basewin,&x,&y);
						if (x != ox || y != oy){
/*
							DrawPoint(basemap,x,y);
*/
							DrawLine(basemap,ox,oy,x,y);
							ox = x;
							oy = y;
						}
					}
				}else if (ctrlbl[LINE].status == ON){
					if (basepress_sw == ON){
						ox = ex;
						oy = ey;
						PwGetMousePosition(basewin,&ex,&ey);
						if (ex != ox || ey != oy){
							SetRubberBand(basemap,&mapsave);
							DrawLine(basemap,sx,sy,ox,oy);
							DrawLine(basemap,sx,sy,ex,ey);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							ox = ex;
							oy = ey;
						}
					}
				}else if (ctrlbl[BOX].status == ON){
					if (basepress_sw == ON){
						ox = ex;
						oy = ey;
						PwGetMousePosition(basewin,&ex,&ey);
						if (ex != ox || ey != oy){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,sx,sy,ox,oy);
							DrawRectangle(basemap,sx,sy,ex,ey);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							ox = ex;
							oy = ey;
						}
					}
				}else if (ctrlbl[BOXF].status == ON){
					if (basepress_sw == ON){
						ox = ex;
						oy = ey;
						PwGetMousePosition(basewin,&ex,&ey);
						if (ex != ox || ey != oy){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,sx,sy,ox,oy);
							DrawRectangle(basemap,sx,sy,ex,ey);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							ox = ex;
							oy = ey;
						}
					}
				}else if (ctrlbl[ARC].status == ON){
					if (basepress_sw == ON){
						ox = ex;
						oy = ey;
						PwGetMousePosition(basewin,&ex,&ey);
						if (ex != ox || ey != oy){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,sx,sy,ox,oy);
							DrawRectangle(basemap,sx,sy,ex,ey);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							ox = ex;
							oy = ey;
						}
					}
				}else if (ctrlbl[ARCF].status == ON){
					if (basepress_sw == ON){
						ox = ex;
						oy = ey;
						PwGetMousePosition(basewin,&ex,&ey);
						if (ex != ox || ey != oy){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,sx,sy,ox,oy);
							DrawRectangle(basemap,sx,sy,ex,ey);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							ox = ex;
							oy = ey;
						}
					}
				}else if (ctrlbl[MAG].status == ON){
					if (magloc_sw == OFF){
						PwGetMousePosition(basewin,&x,&y);
						SetRubberBand(basemap,&mapsave);
						if (x != ox || y != oy){
							if (ox != INVVAL && oy != INVVAL){
								DrawRectangle(basemap,ox,oy,ox+MAGMAPWD+1,
												oy+MAGMAPHT+1);
							}
							DrawRectangle(basemap,x,y,x+MAGMAPWD+1,
											y+MAGMAPHT+1);
						}
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
						ox = x;
						oy = y;
					}
				}else if (ctrlbl[COPY].status == ON){
					if (copysrc_sw == OFF){
						if (basepress_sw == ON){
							ox = ex;
							oy = ey;
							PwGetMousePosition(basewin,&ex,&ey);
							if (ex != ox || ey != oy){
								SetRubberBand(basemap,&mapsave);
								DrawRectangle(basemap,sx,sy,ox,oy);
								DrawRectangle(basemap,sx,sy,ex,ey);
								UnSetRubberBand(basemap,&mapsave,penpatsv,
												fgpatsv,dmsv);
								ox = ex;
								oy = ey;
							}
						}
					}else{
						ox = ex;
						oy = ey;
						PwGetMousePosition(basewin,&ex,&ey);
						if (ex != ox || ey != oy){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,src_sx-src_ex+ox,
											src_sy-src_ey+oy,ox,oy);
							DrawRectangle(basemap,src_sx-src_ex+ex,
											src_sy-src_ey+ey,ex,ey);
							UnSetRubberBand(basemap,&mapsave,penpatsv,
											fgpatsv,dmsv);
							ox = ex;
							oy = ey;
						}
					}
				}else if (ctrlbl[STR].status == ON){
					if (str_sw == ON){
						PwGetMousePosition(basewin,&sx,&sy);
						SetRubberBand(basemap,&mapsave);
						if (sx != ox || sy != oy){
							if (ox != INVVAL && oy != INVVAL){
								DrawRectangle(basemap,ox,oy,ox+strwidth,
												oy+strheight);
							}
							DrawRectangle(basemap,sx,sy,sx+strwidth,
											sy+strheight);
						}
						UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,dmsv);
						ox = sx;
						oy = sy;
					}
				}
				break;
			}
		}else if (sigrec.win == ctrlwin){
			switch (sigrec.type){
			case	WIN_PRIORITY_T:
			case	WIN_LOCATE_T:
				PwRedrawWin(sigrec.win);
				break;
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,ctrlbl)) != -1){
					if (idx <= STR){
						if (basepress_sw == ON){
							if (ctrlbl[LINE].status == ON){
								SetRubberBand(basemap,&mapsave);
								DrawLine(basemap,sx,sy,ox,oy);
								UnSetRubberBand(basemap,&mapsave,penpatsv,
												fgpatsv,dmsv);
							}else if (ctrlbl[BOX].status == ON ||
									  ctrlbl[BOXF].status == ON ||
									  ctrlbl[ARC].status == ON ||
									  ctrlbl[ARCF].status == ON){
								SetRubberBand(basemap,&mapsave);
								DrawRectangle(basemap,sx,sy,ox,oy);
								UnSetRubberBand(basemap,&mapsave,penpatsv,
												fgpatsv,dmsv);
							}
						}
						if (ctrlbl[MAG].status == ON && idx != MAG){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,ox,oy,ox+MAGMAPWD+1,
											oy+MAGMAPHT+1);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							CloseMag(magwin,magmap);
							magwin = (PWIN *)NULL;
							magloc_sw = OFF;
						}
						if (ctrlbl[COPY].status == ON && idx != COPY){
							SetRubberBand(basemap,&mapsave);
							if (copysrc_sw == OFF){
								if (basepress_sw == ON){
									DrawRectangle(basemap,sx,sy,ox,oy);
								}
							}else{
								DrawRectangle(basemap,src_sx,src_sy,src_ex,
												src_ey);
								DrawRectangle(basemap,src_sx-src_ex+ox,
												src_sy-src_ey+oy,ox,oy);
							}
							UnSetRubberBand(basemap,&mapsave,penpatsv,
											fgpatsv,dmsv);
							copysrc_sw = OFF;
						}
						if (ctrlbl[STR].status == ON && idx != STR){
							SetRubberBand(basemap,&mapsave);
							DrawRectangle(basemap,ox,oy,ox+strwidth,
											oy+strheight);
							UnSetRubberBand(basemap,&mapsave,penpatsv,fgpatsv,
											dmsv);
							CloseStr(strwin,strmap);
							strwin = (PWIN *)NULL;
							str_sw = OFF;
						}
						sidx = DOT;
						eidx = STR;
						CtrlRadioButton(ctrlbl,idx,sidx,eidx);
						if (magwin == (PWIN *)NULL && idx == MAG){
							OpenMag(basewin,&magwin,&magmap);
							PwSetFlushMode(magmap,FLS_NORMAL);
							PwSelectSignal(magwin,WIN_PRIORITY|WIN_LOCATE|
											WIN_PRESS|WIN_RELEASE|WIN_MOVE);
							PwSetCursorPattern(magwin,McHitX,McHitY,McPat);
							magloc_sw = OFF;
							ox = INVVAL;
							oy = INVVAL;
						}
						if (strwin == (PWIN *)NULL && idx == STR){
							ClearBtnList(strbl,STRBTNMAX);
							OpenStr(basewin,&strwin,&strmap,string,strbl);
							PwSelectSignal(strwin,WIN_PRIORITY|WIN_LOCATE|
											WIN_PRESS|WIN_RELEASE);
							strstyle = TS_PLAIN;
							fontstyle = DOT16;
							strwidth = strlen(string) * 8;
							strheight = 16;
							str_sw = ON;
							ox = INVVAL;
							oy = INVVAL;
						}
						basepress_sw = OFF;
					}else if (idx <= NOT){
						sidx = SRC;
						eidx = NOT;
						CtrlRadioButton(ctrlbl,idx,sidx,eidx);
						switch (idx){
						case SRC:
							PwSetDrawMode(basemap,DM_COPY);
							dmsv = DM_COPY;
							break;
						case OR:
							PwSetDrawMode(basemap,DM_OR);
							dmsv = DM_OR;
							break;
						case XOR:
							PwSetDrawMode(basemap,DM_XOR);
							dmsv = DM_XOR;
							break;
						case NOT:
							PwSetDrawMode(basemap,DM_NOT);
							dmsv = DM_NOT;
							break;
						default:
							break;
						}
					}else if (idx <= LOAD){
						if (basepress_sw == ON || ctrlbl[MAG].status == ON || 
							(ctrlbl[COPY].status == ON && copysrc_sw == OFF && 
							 basepress_sw == ON) || 
							(ctrlbl[COPY].status == ON && copysrc_sw == ON) || 
							(ctrlbl[STR].status == ON && str_sw == ON)){
							break;
						}
						if (ctrlbl[idx].status == OFF){
							ReverseButton(ctrlbl,idx);
						}
					}else if (idx <= EXIT){
						if (ctrlbl[idx].status == OFF){
							ReverseButton(ctrlbl,idx);
						}
					}
				}
				break;
			case	WIN_RELEASE_T:
				if ((idx = GetWhichButton(sigrec.win,ctrlbl)) != -1){
					if (idx <= NOT){
						break;
					}else if (idx <= LOAD){
						if (basepress_sw == ON || ctrlbl[MAG].status == ON || 
							(ctrlbl[COPY].status == ON && copysrc_sw == OFF && 
							 basepress_sw == ON) || 
							(ctrlbl[COPY].status == ON && copysrc_sw == ON) || 
							(ctrlbl[STR].status == ON && str_sw == ON)){
							break;
						}
						if (ctrlbl[idx].status == ON){
							ReverseButton(ctrlbl,idx);
						}
					}else if (idx <= EXIT){
						if (ctrlbl[idx].status == ON){
							ReverseButton(ctrlbl,idx);
						}
					}
					switch (idx){
					case SAVE:
						if (SaveMap(sigrec.win,basemap) == -1){
							ErrorDialog(sigrec.win,"ݏo܂ł");
						}
						break;
					case LOAD:
						if (LoadFile(sigrec.win,basewin,basemap) == -1){
							ErrorDialog(sigrec.win,"ǂݍݏo܂ł");
						}
						PwFlushMap(basemap,FLS_NORMAL);
						break;
					case EXIT:
						exit_sw = ExitDialog(sigrec.win,"I܂H");
						break;
					default:
						break;
					}
				}
				break;
			}
		}else if (sigrec.win == palwin){
			switch (sigrec.type){
			case	WIN_PRIORITY_T:
			case	WIN_LOCATE_T:
				PwRedrawWin(sigrec.win);
				break;
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,palbl)) != -1){
					if (idx < PENMAX){
						sidx = 0;
						eidx = PENMAX - 1;
					}else{
						sidx = PENMAX;
						eidx = PENMAX + PATMAX -1 ;
					}
					CtrlRadioButton(palbl,idx,sidx,eidx);
					if (idx < PENMAX){
						SetPenSize(basemap,PenPat[idx].penwidth,
								   PenPat[idx].penheight);
						PwSetPenForm(basemap,PenPat[idx].penpat);
						penpatsv = idx;
					}else{
						PwSetForeground(basemap,FgPat[idx-PENMAX]);
						fgpatsv = FgPat[idx-PENMAX];
					}
				}
				break;
			}
		}else if (sigrec.win == magwin){
			switch (sigrec.type){
			case	WIN_PRIORITY_T:
			case	WIN_LOCATE_T:
				PwRedrawWin(sigrec.win);
				break;
			case	WIN_PRESS_T:
				if (magloc_sw == OFF){
					break;
				}
				magpress_sw = ON;
				PwGetMousePosition(magwin,&x,&y);
				PwSetDrawMode(magmap,DM_XOR);
				PwSetPenSize(magmap,MAGPIXWD,MAGPIXHT);
				DrawMag(magmap,ox,oy,x,y,basemap,dmsv);
				ex = (x/MAGPIXWD)*MAGPIXWD;
				ey = (y/MAGPIXHT)*MAGPIXHT;
				break;
			case	WIN_RELEASE_T:
				if (magloc_sw == OFF){
					break;
				}
				magpress_sw = OFF;
				break;
			case	WIN_MOVE_T:
				if (magloc_sw == OFF || magpress_sw == OFF){
					break;
				}
				PwGetMousePosition(magwin,&x,&y);
				if ((x/MAGPIXWD)*MAGPIXWD != ex || (y/MAGPIXHT)*MAGPIXHT != ey){
					PwSetDrawMode(magmap,DM_XOR);
					PwSetPenSize(magmap,MAGPIXWD,MAGPIXHT);
					DrawMag(magmap,ox,oy,x,y,basemap,dmsv);
					ex = (x/MAGPIXWD)*MAGPIXWD;
					ey = (y/MAGPIXHT)*MAGPIXHT;
				}
				break;
			}
		}else if (sigrec.win == strwin){
			switch (sigrec.type){
			case	WIN_PRIORITY_T:
			case	WIN_LOCATE_T:
				PwRedrawWin(sigrec.win);
				break;
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,strbl)) != -1){
					if (idx <= SHADOW){
						strstyle &= ~(TS_PLAIN|TS_BOLD|TS_OUTLINE|TS_SHADOW);
						if (idx == PLAIN){
							strstyle |= TS_PLAIN;
						}else if (idx == BOLD){
							strstyle |= TS_BOLD;
						}else if (idx == OUTLINE){
							strstyle |= TS_OUTLINE;
						}else if (idx == SHADOW){
							strstyle |= TS_SHADOW;
						}
						sidx = PLAIN;
						eidx = SHADOW;
						CtrlRadioButton(strbl,idx,sidx,eidx);
					}else if (idx <= UNDERLINE){
						if (idx == ITALIC && !(strstyle&TS_ITALIC)){
							strstyle |= TS_ITALIC;
							italic_sw = ON;
							ReverseButton(strbl,idx);
						}else if (idx == UNDERLINE && !(strstyle&TS_UNDERLINE)){
							strstyle |= TS_UNDERLINE;
							underline_sw = ON;
							ReverseButton(strbl,idx);
						}
					}else if (idx <= DOT24){
						fontstyle = idx;
						sidx = DOT16;
						eidx = DOT24;
						CtrlRadioButton(strbl,idx,sidx,eidx);
					}else if (idx <= ENTER){
						ReverseButton(strbl,idx);
					}
				}

				if (fontstyle == DOT16){
					strwidth = strlen(string) * 8;
					strheight = 16;
				}else{
					strwidth = strlen(string) * 12;
					strheight = 24;
				}
				if (strstyle & TS_BOLD){
					strwidth++;
				}else if (strstyle & TS_OUTLINE){
					strwidth += 2;
					strheight += 2;
				}else if (strstyle & TS_SHADOW){
					strwidth += 3;
					strheight += 3;
				}

				if (strstyle & TS_ITALIC){
					strwidth += 3;
				}else if (strstyle & TS_UNDERLINE){
					strheight++;
				}

				break;
			case	WIN_RELEASE_T:
				if ((idx = GetWhichButton(sigrec.win,strbl)) != -1){
					if (idx <= SHADOW){
						/* do nothing */ ;
					}else if (idx <= UNDERLINE){
						if (idx == ITALIC && (strstyle&TS_ITALIC)){
							if (italic_sw == ON){
								italic_sw = OFF;
							}else{
								strstyle &= ~TS_ITALIC;
								ReverseButton(strbl,idx);
							}
						}else if (idx == UNDERLINE && (strstyle&TS_UNDERLINE)){
							if (underline_sw == ON){
								underline_sw = OFF;
							}else{
								strstyle &= ~TS_UNDERLINE;
								ReverseButton(strbl,idx);
							}
						}
					}else if (idx <= DOT24){
						/* do nothing */ ;
					}else if (idx <= ENTER){
						ReverseButton(strbl,idx);
						ReEnterStr(strwin,string,strbl);
					}

				}

				if (fontstyle == DOT16){
					strwidth = strlen(string) * 8;
					strheight = 16;
				}else{
					strwidth = strlen(string) * 12;
					strheight = 24;
				}
				if (strstyle & TS_BOLD){
					strwidth++;
				}else if (strstyle & TS_OUTLINE){
					strwidth += 2;
					strheight += 2;
				}else if (strstyle & TS_SHADOW){
					strwidth += 3;
					strheight += 3;
				}

				if (strstyle & TS_ITALIC){
					strwidth += 3;
				}else if (strstyle & TS_UNDERLINE){
					strheight++;
				}

				break;
			}
		}
	}
/* ASK68k N[Y~ */
	if (str_sw == ON){
		AskClose(strwin);
		AskEnd(strwin);
	}

/* ask68k unlink */
	if (modexec != (mod_exec *)-1){
		munlink(modexec);
	}

	PwDestroyMap(basemap);
	PwDestroyMap(ctrlmap);
	PwDestroyMap(palmap);
	PwTermWin();

	exit(0);
}

/* IvV */
int		GetOpt(argc,argv)
int		argc;
char	*argv[];
{
	int		i,j,rowbyte,cnt = 0;
	char	*env,buf[32],msg[128],*adic;
	FILE	*fp;
	
	ResFile[0] = '\0';
	EditFile[0] = '\0';
	
	for (i = 1; i < argc; i++){
		if (argv[i][0] == '-'){
			switch (argv[i][1]){
			case '?':
			case 'h':
			case 'H':
				Usage();
				return -1;
				break;
			case 'r':
			case 'R':
				strcpy(ResFile,argv[i] + 2);
				break;
			case 'g':
			case 'G':
				for (j = 2; argv[i][j]; j++){
					if (argv[i][j] == 'x' || argv[i][j] == 'X'){
						argv[i][j] = '\0';
						BaseWidth = atoi(argv[i] + 2) + 2;
						break;
					}
				}
				BaseHeight = atoi(argv[i] + j + 1) + 2;
				if (BaseWidth <= 0 || BaseHeight <= 0){
					BaseWidth = BASEWIDTH;
					BaseHeight = BASEHEIGHT;
				}
				break;
			default:
				sprintf(msg,"%s:sȃIvVł `%s'",argv[0],argv[i]);
				ErrorDialog(PwGetRootWin(),msg);
				return -1;
				break;
			}
		}else{
			cnt++;
			switch (cnt){
			case 1:
				strcpy(EditFile,argv[i]);
				break;
			default:
				sprintf(msg,"%s:sȃp[^ł `%s'",argv[0],argv[i]);
				ErrorDialog(PwGetRootWin(),msg);
				return -1;
				break;
			}
		}
	}
	if (ResFile[0] == '\0'){
		if ((env = getenv(RESENV)) == (char *)NULL){
			strcpy(ResFile,RESFILE);
		}else{
			strcpy(ResFile,env);
		}
	}
	if (EditFile[0] != '\0'){
		if ((fp = fopen(EditFile,"r")) != NULL){
			if (fread(buf,1,strlen(PWGID),fp) == NULL){
				sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],EditFile);
				ErrorDialog(PwGetRootWin(),msg);
				fclose(fp);
				return -1;
			}
			if (strncmp(buf,PWGID,strlen(PWGID))){
				sprintf(msg,"%s:`%s'̓tH[}bgsł",argv[0],
						EditFile);
				ErrorDialog(PwGetRootWin(),msg);
				fclose(fp);
				return -1;
			}
			if (fscanf(fp,"%d%d%d",&rowbyte,&BaseWidth,&BaseHeight) != 3){
				sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],EditFile);
				ErrorDialog(PwGetRootWin(),msg);
				fclose(fp);
				return -1;
			}
			BaseWidth += 2;
			BaseHeight += 2;
			fclose(fp);
		}
	}
/* t@C擾 */
	if ((adic = getenv(ADIC)) == NULL){
		sprintf(DicM,"%s/%s",DICDIR,DICM);
		sprintf(DicS,"%s/%s",DICDIR,DICS);
	}else{
		sprintf(DicM,"%s/%s",adic,DICM);
		sprintf(DicS,"%s/%s",adic,DICS);
	}
	return 0;
}

/* gp@\ */
int		Usage()
{
	fprintf(stderr,"RGTool Ver %s (Raku Gaki Tool by WADACHI)\n",VER);
	fprintf(stderr,"usage  : RGTool [file] [-option]\n");
	fprintf(stderr,"option : -r\[Xt@CilFRGTool.RESj\n");
	fprintf(stderr,"         -gx         ilF320x200j\n");
	fprintf(stderr,"         -?                 usage \\n");
	fflush(stderr);
	return 0;
}

/* vbV{^` */
int		DrawPushButton(map,left,top,width,height,title,attr,btnlist)
PWGMAP	*map;
int		left;
int		top;
int		width;
int		height;
char	*title;
int		attr;
BTNLIST	*btnlist;
{
	int				i;
	
	for (i = 0; btnlist[i].map != (PWGMAP *)-1; i++){
		if (btnlist[i].map == (PWGMAP *)NULL){
			btnlist[i].map = map;
			btnlist[i].left = left;
			btnlist[i].top = top;
			btnlist[i].width = width;
			btnlist[i].height = height;
			strcpy(btnlist[i].title,title);
			btnlist[i].attr = attr;
			btnlist[i].status = OFF;
			if (btnlist[i+1].map != (PWGMAP *)-1){
				btnlist[i+1].map = (PWGMAP *)NULL;
			}

			PwDrawLabel(map,left,top,width,height,title,attr);

			return 0;
		}
	}
	return -1;
}

/* \[X擾 */
int		GetRes(argc,argv)
int		argc;
char	*argv[];
{
	int		i,j,k;
	FILE	*fp;
	char	buf[128],msg[128];

	if ((fp = fopen(ResFile,"r")) == NULL){
		sprintf(msg,"%s:`%s'I[vo܂",argv[0],ResFile);
		ErrorDialog(PwGetRootWin(),msg);
		return -1;
	}

	for (i = 0; i < PENMAX; i++){
		if (ReadRes(buf,sizeof buf,fp) == NULL){
			sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],ResFile);
			ErrorDialog(PwGetRootWin(),msg);
			return -1;
		}
		sscanf(buf,"%d %d",&PenPat[i].penwidth,&PenPat[i].penheight);
		for (j = 0; j < 16; j++){
			if (ReadRes(buf,sizeof buf,fp) == NULL){
				sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],ResFile);
				ErrorDialog(PwGetRootWin(),msg);
				return -1;
			}
			PenPat[i].penpat[j] = 0;
			for (k = 0; k < 16; k++){
				PenPat[i].penpat[j] = PenPat[i].penpat[j] << 1;
				if (buf[k] != ' '){
					PenPat[i].penpat[j] |= 1;
				}
			}
		}
	}

	for (i = 0; i < PATMAX; i++){
		for (j = 0; j < 16; j++){
			if (ReadRes(buf,sizeof buf,fp) == NULL){
				sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],ResFile);
				ErrorDialog(PwGetRootWin(),msg);
				return -1;
			}
			FgPat[i][j] = 0;
			for (k = 0; k < 16; k++){
				FgPat[i][j] = FgPat[i][j] << 1;
				if (buf[k] != ' '){
					FgPat[i][j] |= 1;
				}
			}
		}
	}

	if (ReadRes(buf,sizeof buf,fp) == NULL){
		sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],ResFile);
		ErrorDialog(PwGetRootWin(),msg);
		return -1;
	}
	sscanf(buf,"%d %d",&McHitX,&McHitY);
	McHitX--;	/* basewin  basemap ̍W 1dot Ăׂ̕␳ */
	McHitY--;	/* basewin  basemap ̍W 1dot Ăׂ̕␳ */
	for (i = 0; i < 32; i++){
		if (ReadRes(buf,sizeof buf,fp) == NULL){
			sprintf(msg,"%s:`%s'ǂ߂܂",argv[0],ResFile);
			ErrorDialog(PwGetRootWin(),msg);
			return -1;
		}
		McPat[i] = 0;
		for (j = 0; j < 16; j++){
			McPat[i] = McPat[i] << 1;
			if (buf[j] != ' '){
				McPat[i] |= 1;
			}
		}
	}

	fclose(fp);

	return 0;
}

/* \[Xǂݍ */
char	*ReadRes(buf,size,fp)
char	*buf;
int		size;
FILE	*fp;
{
	char	*ret;
	
	if ((ret = fgets(buf,size,fp)) == NULL){
		return ret;
	}
	while (buf[0] == '#'){
		if ((ret = fgets(buf,size,fp)) == NULL){
			return ret;
		}
	}
	return ret;
}

/* _` */
int		DrawPoint(map,x,y)
PWGMAP	*map;
int		x;
int		y;
{
	return PwDrawPoint(map, x - PenWidth / 2, y - PenHeight / 2);
}

/* ` */
int		DrawLine(map,sx,sy,ex,ey)
PWGMAP	*map;
int		sx;
int		sy;
int		ex;
int		ey;
{
	return PwDrawLine(map, sx - PenWidth / 2, sy - PenHeight / 2,
						   ex - PenWidth / 2, ey - PenHeight / 2);
}

/* yTCYݒ */
int		SetPenSize(map,width,height)
PWGMAP	*map;
int		width;
int		height;
{
	PenWidth = width;
	PenHeight = height;
	return PwSetPenSize(map,width,height);
}

/* }EX̎wvbV{^擾 */
int		GetWhichButton(pwin,btnlist)
PWIN	*pwin;
BTNLIST	*btnlist;
{
	int		x,y,i;
	
	PwGetMousePosition(pwin,&x,&y);
	for (i = 0; btnlist[i].map != (PWGMAP *)-1; i++){
		if (btnlist[i].map == (PWGMAP *)NULL){
			return -1;
		}else{
			if (btnlist[i].left <= x && 
				x <= (btnlist[i].left + btnlist[i].width) && 
				btnlist[i].top <= y && 
				y <= (btnlist[i].top + btnlist[i].height)){

				return i;
			}
		}
	}
	return -1;
}

/* vbV{^] */
int		ReverseButton(btnlist,idx)
BTNLIST	*btnlist;
int		idx;
{
	PWGMAP			mapsave;
	extern int		_PwCopyPwgmap();

	_PwCopyPwgmap(btnlist[idx].map,&mapsave);
	PwSetDrawMode(btnlist[idx].map,DM_XOR);
	PwSetForeground(btnlist[idx].map,BlackPat);
	PwSetPenForm(btnlist[idx].map,BlackPat);
	PwSetPenSize(btnlist[idx].map,1,1);
	PwSetFlushMode(btnlist[idx].map,FLS_NORMAL);

	PwFillRectangle(btnlist[idx].map,btnlist[idx].left+1,btnlist[idx].top+1,
					btnlist[idx].width-2,btnlist[idx].height-2);
	
	if (btnlist[idx].status == ON){
		btnlist[idx].status = OFF;
	}else{
		btnlist[idx].status = ON;
	}

	_PwCopyPwgmap(&mapsave,btnlist[idx].map);

	return 0;
}

/* fBI{^ */
int		CtrlRadioButton(btnlist,idx,sidx,eidx)
BTNLIST	*btnlist;
int		idx;
int		sidx;
int		eidx;
{
	int		i;

	if (btnlist[idx].status == ON){
		return 0;
	}
	for (i = sidx; i <= eidx; i++){
		if (btnlist[i].status == ON){
			ReverseButton(btnlist,i);
			ReverseButton(btnlist,idx);
			return 0;
		}
	}
	return -1;
}

/* lp` */
int		DrawRectangle(map,sx,sy,ex,ey)
PWGMAP	*map;
int		sx;
int		sy;
int		ex;
int		ey;
{
	int		swap;

	if (ex < sx){
		swap = sx;
		sx = ex;
		ex = swap;
	}
	if (ey < sy){
		swap = sy;
		sy = ey;
		ey = swap;
	}
	
	return PwDrawRectangle(map,sx-PenWidth/2,sy-PenHeight/2,
			ex-PenWidth/2-sx+PenWidth/2,ey-PenHeight/2-sy+PenHeight/2);
}

/* lphׂ */
int		FillRectangle(map,sx,sy,ex,ey)
PWGMAP	*map;
int		sx;
int		sy;
int		ex;
int		ey;
{
	int		swap;

	if (ex < sx){
		swap = sx;
		sx = ex;
		ex = swap;
	}
	if (ey < sy){
		swap = sy;
		sy = ey;
		ey = swap;
	}
	
	return PwFillRectangle(map,sx,sy,ex - sx,ey - sy);
}

/* ~ʕ` */
int		DrawArc(map,sx,sy,ex,ey,ang1,ang2)
PWGMAP	*map;
int		sx;
int		sy;
int		ex;
int		ey;
int		ang1;
int		ang2;
{
	int		swap;

	if (ex < sx){
		swap = sx;
		sx = ex;
		ex = swap;
	}
	if (ey < sy){
		swap = sy;
		sy = ey;
		ey = swap;
	}
	
	return PwDrawArc(map,sx-PenWidth/2,sy-PenHeight/2,
			ex-PenWidth/2-sx+PenWidth/2,ey-PenHeight/2-sy+PenHeight/2,
			ang1,ang2);
}

/* ~ʓhׂ */
int		FillArc(map,sx,sy,ex,ey,ang1,ang2)
PWGMAP	*map;
int		sx;
int		sy;
int		ex;
int		ey;
int		ang1;
int		ang2;
{
	int		swap;

	if (ex < sx){
		swap = sx;
		sx = ex;
		ex = swap;
	}
	if (ey < sy){
		swap = sy;
		sy = ey;
		ey = swap;
	}
	
	return PwFillArc(map,sx,sy,ex - sx,ey - sy,ang1,ang2);
}

/* o[oh`摮ݒ */
int		SetRubberBand(map,mapsave)
PWGMAP	*map;
PWGMAP	*mapsave;
{
	extern int		_PwCopyPwgmap();

	_PwCopyPwgmap(map,mapsave);
	SetPenSize(map,1,1);
	PwSetPenForm(map,BlackPat);
	PwSetForeground(map,BlackPat);
	PwSetDrawMode(map,DM_XOR);
	return 0;
}

/* o[oh`摮 */
int		UnSetRubberBand(map,mapsave,penpatsv,fgpatsv,dmsv)
PWGMAP	*map;
PWGMAP	*mapsave;
int		penpatsv;
int		fgpatsv[][16];
int		dmsv;
{
	extern int		_PwCopyPwgmap();

	_PwCopyPwgmap(mapsave,map);
	SetPenSize(map,PenPat[penpatsv].penwidth,PenPat[penpatsv].penheight);
	PwSetPenForm(map,PenPat[penpatsv].penpat);
	PwSetForeground(map,fgpatsv);
	PwSetDrawMode(map,dmsv);
	return 0;
}

/* LoXۑ */
int		SaveMap(win,map)
PWIN	*win;
PWGMAP	*map;
{
	PWIN	*filewin;
	PWGMAP	*filemap;
	int		left,top,cnt,ok_sw = OFF,can_sw = OFF,ret = 0,idx;
	char	file[64],buf[128];
	PWSIGNAL	sigrec;
	BTNLIST		btnlist[3];
	
	ClearBtnList(btnlist,2);
	
	PwGetMousePosition(win,&left,&top);
	filewin = PwCreateWin(win,left,top,SAVEWIDTH,SAVEHEIGHT);
	PwSetWinAttr(filewin,WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
	filemap = PwCreateMap(SAVEWIDTH,SAVEHEIGHT);
	PwSetMapWin(filemap,filewin,0,0,SAVEWIDTH,SAVEHEIGHT);

	PwOpenWin(filewin);
	
	write(PwGetWinPath(filewin),"t@CF",12);
	PwPutString(filewin,EditFile);
	cnt = readln(PwGetWinPath(filewin),file,2 * SAVEWIDTH / 8 - 16);
	file[cnt - 1] = '\0';
	write(PwGetWinPath(filewin),"\033[1v",4);

	sprintf(buf,"%s%s","t@CF",file);
	if (((SAVEWIDTH-16)/8) < strlen(buf)){
		PwDrawString(filemap,8,4+16,buf+(SAVEWIDTH-16)/8,TS_PLAIN);
		buf[(SAVEWIDTH-16)/8] = '\0';
	}
	PwDrawString(filemap,8,4,buf,TS_PLAIN);

	PwDrawRectangle(filemap,0,0,SAVEWIDTH-1,SAVEHEIGHT-1);
	DrawPushButton(filemap,4,SAVEHEIGHT-BTNHEIGHT-4,BTNWIDTH,BTNHEIGHT,"O K",
					LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,btnlist);
	DrawPushButton(filemap,4+BTNWIDTH+4,SAVEHEIGHT-BTNHEIGHT-4,BTNWIDTH,
					BTNHEIGHT,"CAN",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|
					TS_PLAIN,btnlist);
	PwFlushMap(filemap,FLS_NORMAL);

	PwSelectSignal(filewin,WIN_PRESS|WIN_RELEASE);

	while(ok_sw == OFF && can_sw == OFF){
		PwGetSignal(&sigrec);
		if (sigrec.win == filewin){
			switch (sigrec.type){
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
				}
				break;
			case	WIN_RELEASE_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
					if (idx == 0){
						ok_sw = ON;
					}else{
						can_sw = ON;
					}
				}
				break;
			default:
				break;
			}
		}
	}

	if (ok_sw == ON){
		if((ret = SaveMapToFile(file,map)) == 0){
			strcpy(EditFile,file);
		}
	}
	
	PwCloseWin(filewin);
	PwDestroyWin(filewin);
	PwDestroyMap(filemap);

	return ret;
}

/* PWGMAPt@C */
int		SaveMapToFile(file,map)
char	*file;
PWGMAP	*map;
{
	FILE	*fp;
	char	buf[32];
	int		i;
		
	if ((fp = fopen(file,"w")) == NULL){
		return -1;
	}

	sprintf(buf,FILEHEADER,PWGID,map->maprow,map->mapwidth,map->mapheight);

	if (fwrite(buf,1,strlen(buf),fp) == NULL){
		fclose(fp);
		return -1;
	}

	for (i = 0; i < (map->maprow * map->mapheight); i++){
		if (putc(map->mapaddress[i],fp) == -1){
			fclose(fp);
			return -1;
		}
	}
	fclose(fp);
	return 0;
}

/* G[_CAO\ */
int		ErrorDialog(win,str)
PWIN	*win;
char	*str;
{
	PWIN	*edwin;
	PWGMAP	*edmap;
	int		left,top,ok_sw = OFF,idx;
	PWSIGNAL	sigrec;
	BTNLIST		btnlist[2];
	
	ClearBtnList(btnlist,1);
	
	PwGetMousePosition(win,&left,&top);
	edwin = PwCreateWin(win,left,top,8+strlen(str)*8+8,4+BTNHEIGHT*2+4);
	PwSetWinAttr(edwin,WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
	write(PwGetWinPath(edwin),"\033[1v",4);
	edmap = PwCreateMap(8+strlen(str)*8+8,4+BTNHEIGHT*2+4);
	PwSetMapWin(edmap,edwin,0,0,8+strlen(str)*8+8,4+BTNHEIGHT*2+4);

	PwDrawRectangle(edmap,0,0,8+strlen(str)*8+7,4+BTNHEIGHT*2+3);
	PwDrawString(edmap,8,4,str,TS_PLAIN);
	DrawPushButton(edmap,(8+strlen(str)*8+8-BTNWIDTH)/2,
					4+BTNHEIGHT*2+4-BTNHEIGHT-4,BTNWIDTH,BTNHEIGHT,"O K",
					LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,btnlist);

	PwOpenWin(edwin);
	PwFlushMap(edmap,FLS_NORMAL);
	
	PwSelectSignal(edwin,WIN_PRESS|WIN_RELEASE);

	while(ok_sw == OFF){
		PwGetSignal(&sigrec);
		if (sigrec.win == edwin){
			switch (sigrec.type){
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
				}
				break;
			case	WIN_RELEASE_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
					if (idx == 0){
						ok_sw = ON;
					}
				}
				break;
			default:
				break;
			}
		}
	}

	PwCloseWin(edwin);
	PwDestroyWin(edwin);
	PwDestroyMap(edmap);

	return 0;
}

/* t@C[h */
int		LoadFile(win,basewin,basemap)
PWIN	*win;
PWIN	*basewin;
PWGMAP	*basemap;
{
	PWIN	*filewin;
	PWGMAP	*filemap;
	int		left,top,cnt,ok_sw = OFF,can_sw = OFF,ret = 0,idx,rowbyte;
	int		mapwidth,mapheight;
	char	file[64],buf[32],buf2[128];
	PWSIGNAL	sigrec;
	BTNLIST		btnlist[3];
	FILE	*fp;
	
	ClearBtnList(btnlist,2);
	
	PwGetMousePosition(win,&left,&top);
	filewin = PwCreateWin(win,left,top,SAVEWIDTH,SAVEHEIGHT);
	PwSetWinAttr(filewin,WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
	filemap = PwCreateMap(SAVEWIDTH,SAVEHEIGHT);
	PwSetMapWin(filemap,filewin,0,0,SAVEWIDTH,SAVEHEIGHT);

	PwOpenWin(filewin);
	
	write(PwGetWinPath(filewin),"t@CF",12);
	PwPutString(filewin,EditFile);
	cnt = readln(PwGetWinPath(filewin),file,2 * SAVEWIDTH / 8 - 16);
	file[cnt - 1] = '\0';
	write(PwGetWinPath(filewin),"\033[1v",4);

	sprintf(buf2,"t@CF%s",file);
	if (((SAVEWIDTH-16)/8) < strlen(buf2)){
		PwDrawString(filemap,8,4+16,buf2+(SAVEWIDTH-16)/8,TS_PLAIN);
		buf2[(SAVEWIDTH-16)/8] = '\0';
	}
	PwDrawString(filemap,8,4,buf2,TS_PLAIN);

	PwDrawRectangle(filemap,0,0,SAVEWIDTH-1,SAVEHEIGHT-1);
	DrawPushButton(filemap,4,SAVEHEIGHT-BTNHEIGHT-4,BTNWIDTH,BTNHEIGHT,"O K",
					LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,btnlist);
	DrawPushButton(filemap,4+BTNWIDTH+4,SAVEHEIGHT-BTNHEIGHT-4,BTNWIDTH,
					BTNHEIGHT,"CAN",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|
					TS_PLAIN,btnlist);
	PwFlushMap(filemap,FLS_NORMAL);

	PwSelectSignal(filewin,WIN_PRESS|WIN_RELEASE);

	while(ok_sw == OFF && can_sw == OFF){
		PwGetSignal(&sigrec);
		if (sigrec.win == filewin){
			switch (sigrec.type){
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
				}
				break;
			case	WIN_RELEASE_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
					if (idx == 0){
						ok_sw = ON;
					}else{
						can_sw = ON;
					}
				}
				break;
			default:
				break;
			}
		}
	}

	if (ok_sw == ON){
		ret = 0;
		if ((fp = fopen(file,"r")) == NULL){
			ret = -1;
		}
		if (ret == 0){
			if (fread(buf,1,strlen(PWGID),fp) == NULL){
				fclose(fp);
				ret = -1;
			}
		}
		if (ret == 0){
			if (strncmp(buf,PWGID,strlen(PWGID))){
				fclose(fp);
				ret = -1;
			}
		}
		if (ret == 0){
			if (fscanf(fp,"%d%d%d",&rowbyte,&mapwidth,&mapheight) != 3){
				fclose(fp);
				ret= -1;
			}
		}
		if (ret == 0){
			fclose(fp);
		}
		if (ret == 0){
			if (basemap->mapwidth != mapwidth || 
				basemap->mapheight != mapheight){
				BaseWidth = mapwidth + 2;
				BaseHeight = mapheight + 2;
				PwSetWinAttr(basewin,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADER|
								WIN_MP_SHADEB|WIN_DESTROY);
				PwResizeWin(basewin,BaseWidth,BaseHeight);
				PwSetWinAttr(basewin,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADER|
								WIN_MP_SHADEB|WIN_SIZE|WIN_DESTROY);
				PwResizeMap(basemap,mapwidth,mapheight);
				PwSetMapWin(basemap,basewin,1,1,mapwidth,mapheight);
			}
		}
		if (ret == 0){
			if((ret = LoadFileToMap(file,basemap)) == 0){
				strcpy(EditFile,file);
			}
		}
	}
	
	PwCloseWin(filewin);
	PwDestroyWin(filewin);
	PwDestroyMap(filemap);

	return ret;
}

/* t@Cǂݍ */
int		LoadFileToMap(file,map)
char	*file;
PWGMAP	*map;
{
	FILE	*fp;
	char	buf[32];
	int		i;
		
	if ((fp = fopen(file,"r")) == NULL){
		return -1;
	}

	if (fread(buf,1,strlen(PWGID),fp) == NULL){
		fclose(fp);
		return -1;
	}
	if (strncmp(buf,PWGID,strlen(PWGID))){
		fclose(fp);
		return -1;
	}
	if (fgets(buf,sizeof buf,fp) == NULL){
		fclose(fp);
		return -1;
	}
	for (i = 0; i < (map->maprow * map->mapheight); i++){
		if ((map->mapaddress[i] = fgetc(fp)) == EOF){
			fclose(fp);
			return -1;
		}
	}
	fclose(fp);
	return 0;
}

/* I_CAO\ */
int		ExitDialog(win,str)
PWIN	*win;
char	*str;
{
	PWIN	*edwin;
	PWGMAP	*edmap;
	int		left,top,ok_sw = OFF,can_sw = OFF,idx;
	PWSIGNAL	sigrec;
	BTNLIST		btnlist[3];
	
	ClearBtnList(btnlist,2);
	
	PwGetMousePosition(win,&left,&top);
	edwin = PwCreateWin(win,left,top,8+strlen(str)*8+8,4+BTNHEIGHT*2+4);
	PwSetWinAttr(edwin,WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
	write(PwGetWinPath(edwin),"\033[1v",4);
	edmap = PwCreateMap(8+strlen(str)*8+8,4+BTNHEIGHT*2+4);
	PwSetMapWin(edmap,edwin,0,0,8+strlen(str)*8+8,4+BTNHEIGHT*2+4);

	PwDrawRectangle(edmap,0,0,8+strlen(str)*8+7,4+BTNHEIGHT*2+3);
	PwDrawString(edmap,8,4,str,TS_PLAIN);
	DrawPushButton(edmap,4,4+BTNHEIGHT*2+4-BTNHEIGHT-4,BTNWIDTH,BTNHEIGHT,
					"O K",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,
					btnlist);
	DrawPushButton(edmap,4+BTNWIDTH+4,4+BTNHEIGHT*2+4-BTNHEIGHT-4,BTNWIDTH,
					BTNHEIGHT,"CAN",LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|
					TS_PLAIN,btnlist);

	PwOpenWin(edwin);
	PwFlushMap(edmap,FLS_NORMAL);

	PwSelectSignal(edwin,WIN_PRESS|WIN_RELEASE);

	while(ok_sw == OFF && can_sw == OFF){
		PwGetSignal(&sigrec);
		if (sigrec.win == edwin){
			switch (sigrec.type){
			case	WIN_PRESS_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
				}
				break;
			case	WIN_RELEASE_T:
				if ((idx = GetWhichButton(sigrec.win,btnlist)) != -1){
					ReverseButton(btnlist,idx);
					if (idx == 0){
						ok_sw = ON;
					}else{
						can_sw = ON;
					}
				}
				break;
			default:
				break;
			}
		}
	}

	PwCloseWin(edwin);
	PwDestroyWin(edwin);
	PwDestroyMap(edmap);

	if (ok_sw == ON){
		return ON;
	}else{
		return OFF;
	}
}

/* EBhEʒu`FbN */
int		LocationCheck(left,top,basewin,ctrlwin,palwin,magwin,strwin)
int		*left;
int		*top;
PWIN	*basewin;
PWIN	*ctrlwin;
PWIN	*palwin;
PWIN	*magwin;
PWIN	*strwin;
{
	int		minleft,mintop,maxright,maxbottom;
	PWIN	pwinsave;

	extern int	_PwCopyPwin();
	
	_PwCopyPwin(basewin,&pwinsave);
	minleft = *left;
	mintop = *top;
	maxright = *left + pwinsave.width;
	maxbottom = *top + pwinsave.height;

	_PwCopyPwin(ctrlwin,&pwinsave);
	if ((*left + pwinsave.left) < minleft){
		minleft = *left + pwinsave.left;
	}
	if ((*top + pwinsave.top) < mintop){
		mintop = *top + pwinsave.top;
	}
	if (maxright < (*left + pwinsave.left + pwinsave.width)){
		maxright = *left + pwinsave.left + pwinsave.width;
	}
	if (maxbottom < (*top + pwinsave.top + pwinsave.height)){
		maxbottom = *top + pwinsave.top + pwinsave.height;
	}

	_PwCopyPwin(palwin,&pwinsave);
	if ((*left + pwinsave.left) < minleft){
		minleft = *left + pwinsave.left;
	}
	if ((*top + pwinsave.top) < mintop){
		mintop = *top + pwinsave.top;
	}
	if (maxright < (*left + pwinsave.left + pwinsave.width)){
		maxright = *left + pwinsave.left + pwinsave.width;
	}
	if (maxbottom < (*top + pwinsave.top + pwinsave.height)){
		maxbottom = *top + pwinsave.top + pwinsave.height;
	}

	if (magwin != (PWIN *)NULL){
		_PwCopyPwin(magwin,&pwinsave);
		if ((*left + pwinsave.left) < minleft){
			minleft = *left + pwinsave.left;
		}
		if ((*top + pwinsave.top) < mintop){
			mintop = *top + pwinsave.top;
		}
		if (maxright < (*left + pwinsave.left + pwinsave.width)){
			maxright = *left + pwinsave.left + pwinsave.width;
		}
		if (maxbottom < (*top + pwinsave.top + pwinsave.height)){
			maxbottom = *top + pwinsave.top + pwinsave.height;
		}
	}

	if (strwin != (PWIN *)NULL){
		_PwCopyPwin(strwin,&pwinsave);
		if ((*left + pwinsave.left) < minleft){
			minleft = *left + pwinsave.left;
		}
		if ((*top + pwinsave.top) < mintop){
			mintop = *top + pwinsave.top;
		}
		if (maxright < (*left + pwinsave.left + pwinsave.width)){
			maxright = *left + pwinsave.left + pwinsave.width;
		}
		if (maxbottom < (*top + pwinsave.top + pwinsave.height)){
			maxbottom = *top + pwinsave.top + pwinsave.height;
		}
	}

	if (minleft < MIN_X){
		*left += (MIN_X - minleft);
	}
	if (mintop < MIN_Y){
		*top += (MIN_Y - mintop);
	}
	if (MAX_X < maxright){
		*left -= (maxright - MAX_X);
	}
	if (MAX_Y < maxbottom){
		*top -= (maxbottom - MAX_Y);
	}

	return 0;
}

/* gEBhEI[v */
int		OpenMag(basewin,magwin,magmap)
PWIN	*basewin;
PWIN	**magwin;
PWGMAP	**magmap;
{
	int		x,y;

	PwGetMousePosition(basewin,&x,&y);
	*magwin = PwCreateWin(basewin,x,y,MAGWIDTH,MAGHEIGHT);
	PwSetWinAttr(*magwin,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADER|
					WIN_MP_SHADEB|WIN_SIZE|WIN_DESTROY);
	write(PwGetWinPath(*magwin),"\033[1v",4);
	*magmap = PwCreateMap(MAGWIDTH-1,MAGHEIGHT-2);
	PwSetMapWin(*magmap,*magwin,1,1,MAGWIDTH-1,MAGHEIGHT-2);
	PwSetFlushMode(*magmap,FLS_NORMAL);
	PwOpenWin(*magwin);
 
	return 0;
}

/* gEBhEN[Y */
int		CloseMag(magwin,magmap)
PWIN	*magwin;
PWGMAP	*magmap;
{
	PwDestroyMap(magmap);
	PwDestroyWin(magwin);

	return 0;
}

/* LoXgEBhEɃRs[ */
int		CopyMapToMag(basemap,ox,oy,magmap)
PWGMAP	*basemap;
int		ox;
int		oy;
PWGMAP	*magmap;
{
	int		x,y,magx,magy;
	PWGMAP	mapsave;
	extern int	_PwCopyPwgmap();

	_PwCopyPwgmap(magmap,&mapsave);
	ox++;
	oy++;
	PwSetPenSize(magmap,1,1);
	for (magy = 0; magy < MAGHEIGHT; magy += MAGPIXHT){
		PwDrawLine(magmap,0,magy,MAGWIDTH-1,magy);
	}
	for (magx = 0; magx < MAGWIDTH; magx += MAGPIXWD){
		PwDrawLine(magmap,magx,0,magx,MAGHEIGHT-1);
	}

	PwSetPenSize(magmap,MAGPIXWD,MAGPIXHT);
	PwSetDrawMode(magmap,DM_XOR);
	for (y = oy,magy = 0; y < (oy + MAGMAPHT); y++,magy += MAGPIXHT){
		for (x = ox,magx = 0; x < (ox + MAGMAPWD); x++,magx += MAGPIXWD){
			if (PwGetPoint(basemap,x,y)){
				PwDrawPoint(magmap,magx,magy);
			}
		}
	}

	_PwCopyPwgmap(&mapsave,magmap);
	return 0;
}

/* gEBhE` */
int		DrawMag(magmap,ox,oy,x,y,basemap,dmode)
PWGMAP	*magmap;
int		ox;
int		oy;
int		x;
int		y;
PWGMAP	*basemap;
int		dmode;
{
	PWGMAP	mapsave;
	extern int	_PwCopyPwgmap();
	
	_PwCopyPwgmap(basemap,&mapsave);
	PwSetPenSize(basemap,1,1);	
	PwSetPenForm(basemap,BlackPat);
	PwSetForeground(basemap,BlackPat);

	if (PwGetPoint(basemap, 1 + ox + x/MAGPIXWD, 1 + oy + y/MAGPIXHT) == 1){
		if (dmode == DM_XOR || dmode == DM_NOT){
			PwDrawPoint(magmap, (x/MAGPIXWD)*MAGPIXWD, (y/MAGPIXHT)*MAGPIXHT);
		}
	}else{
		if (dmode == DM_COPY || dmode == DM_OR || dmode == DM_XOR){
			PwDrawPoint(magmap, (x/MAGPIXWD)*MAGPIXWD, (y/MAGPIXHT)*MAGPIXHT);
		}
	}

	if ((x / MAGPIXWD) < MAGMAPWD && (y / MAGPIXHT) < MAGMAPHT){
		PwDrawPoint(basemap, 1 + ox + x/MAGPIXWD, 1 + oy + y/MAGPIXHT);
	}

	_PwCopyPwgmap(&mapsave,basemap);
	return 0;
}

/* LoXԃRs[ */
int		CopyArea(srcmap,dstmap,sx,sy,ex,ey,dstex,dstey)
PWGMAP	*srcmap;
PWGMAP	*dstmap;
int		sx;
int		sy;
int		ex;
int		ey;
int		dstex;
int		dstey;
{
	int		left,top,width,height,dleft,dtop;

	if (sx < ex){
		left = sx;
		width = ex - sx;
		dleft = dstex - width;
	}else{
		left = ex;
		width = sx - ex;
		dleft = dstex;
	}
	
	if (sy < ey){
		top = sy;
		height = ey - sy;
		dtop = dstey - height;
	}else{
		top = ey;
		height = sy - ey;
		dtop = dstey;
	}
	
	PwCopyArea(srcmap,dstmap,left,top,width,height,dleft,dtop);
	return 0;
}

/* EBhEI[v */
int		OpenStr(basewin,strwin,strmap,string,strbl)
PWIN	*basewin;
PWIN	**strwin;
PWGMAP	**strmap;
char	string[];
BTNLIST	strbl[];
{
	int		cnt,strwidth;
	char	buf[128];

	strwidth = (BaseWidth < STRWIDTH ? STRWIDTH : BaseWidth);
		
/* EBhE */
	*strwin = PwCreateWin(basewin,0,BaseHeight,strwidth,STRHEIGHT);
	PwSetWinAttr(*strwin,WIN_MP_SCREEN|WIN_SIZE|WIN_DESTROY);
/* }bv */
	*strmap = PwCreateMap(strwidth,STRHEIGHT);
	PwSetMapWin(*strmap,*strwin,0,0,strwidth,STRHEIGHT);

/* {^`P */
	PwDrawRectangle(*strmap,0,0,strwidth-1,STRHEIGHT-1);
	DrawPushButton(*strmap,4,STRHEIGHT-4-20*2,6*8,BTNHEIGHT,"׎",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);
	DrawPushButton(*strmap,4,STRHEIGHT-4-20*1,6*8,BTNHEIGHT,"",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);
	DrawPushButton(*strmap,4+6*8,STRHEIGHT-4-20*2,6*8,BTNHEIGHT,"܎",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);

/* ASK68K N */
	AskStart(PwGetWinPath(*strwin));
	write(PwGetWinPath(*strwin),"\033[2J",4);	/* Sʏ */
	write(PwGetWinPath(*strwin),"\033[1;1H",6);	/* HOME J[\ */
	
/* I[v */
	PwOpenWin(*strwin);

/* {^`Q */
	DrawPushButton(*strmap,4+6*8,STRHEIGHT-4-20*1,6*8,BTNHEIGHT,"e",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);
	DrawPushButton(*strmap,8+6*8*2,STRHEIGHT-4-20*2,6*8,BTNHEIGHT,"Α",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);
	DrawPushButton(*strmap,8+6*8*2,STRHEIGHT-4-20*1,6*8,BTNHEIGHT,"",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);

	write(PwGetWinPath(*strwin),"F",8);
	PwPutString(*strwin,string);
	cnt = readln(PwGetWinPath(*strwin),string,strwidth / 8 - 10);
	string[cnt - 1] = '\0';
	write(PwGetWinPath(*strwin),"\033[1v",4);	/* J[\\ */

/* ϊN[Y */
	AskClose(PwGetWinPath(*strwin));

/* {^`R */
	sprintf(buf,"F%s",string);
	PwDrawString(*strmap,8,4,buf,TS_PLAIN);
	DrawPushButton(*strmap,12+6*8*3,STRHEIGHT-4-20*2,6*8,BTNHEIGHT,"16DOT",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);
	DrawPushButton(*strmap,12+6*8*3,STRHEIGHT-4-20*1,6*8,BTNHEIGHT,"24DOT",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);
	DrawPushButton(*strmap,16+6*8*4,STRHEIGHT-4-20*2,6*8,BTNHEIGHT,"",
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN,strbl);

	PwFlushMap(*strmap,FLS_NORMAL);
	ReverseButton(strbl,PLAIN);
	ReverseButton(strbl,DOT16);
 
	return 0;
}

/* ē */
int		ReEnterStr(strwin,string,strbl)
PWIN	*strwin;
char	string[];
BTNLIST	strbl[];
{
	int		cnt,strwidth;

	strwidth = (BaseWidth < STRWIDTH ? STRWIDTH : BaseWidth);

	write(PwGetWinPath(strwin),"\033[1;1H",6);	/* HOME J[\ */
	write(PwGetWinPath(strwin),"\033[2K",4);	/* J[\s */
	write(PwGetWinPath(strwin),"\033[0v",4);	/* J[\\ */
	write(PwGetWinPath(strwin),"F",8);
	PwPutString(strwin,string);
	cnt = readln(PwGetWinPath(strwin),string,strwidth / 8 - 10);
	string[cnt - 1] = '\0';
	write(PwGetWinPath(strwin),"\033[1v",4);	/* J[\\ */

/* ϊN[Y */
	AskClose(PwGetWinPath(*strwin));

	return 0;
}

/* EBhEN[Y */
int		CloseStr(strwin,strmap)
PWIN	*strwin;
PWGMAP	*strmap;
{
	AskEnd(PwGetWinPath(strwin));
	PwDestroyMap(strmap);
	PwDestroyWin(strwin);
	
	return 0;
}

/* BTNLIST ݒ */
int		ClearBtnList(btnlist,maxidx)
BTNLIST	*btnlist;
int		maxidx;
{
	int		i;

	for (i = 0; i < maxidx; i++){
		btnlist[i].map = (PWGMAP *)NULL;			/* last data */
	}
	btnlist[i].map = (PWGMAP *)-1;	/* terminate */

	return 0;
}

/* ASK68K N */
int		AskStart(path)
int		path;
{
/* ϊ[h擾 */
	if (_fp_getknjmd(path) == -1){
		return -1;
	}
/* ϊ@\Jn */
	if (_fp_setknjmd(path,1,15,DicM,DicS) == -1){
		return -1;
	}
	return 0;
}

/* ϊN[Y */
int		AskClose(path)
int		path;
{
/* ϊN[Y */
	if (_fp_knjctrl(path,1,0) != 0){
		return -1;
	}
	return 0;
}

/* ASK68K I */
int		AskEnd(path)
int		path;
{
/* ϊ@\~ */
	if (_fp_setknjmd(path,0,0,DicM,DicS) == -1){
		return -1;
	}
	return 0;
}
